<?php

declare(strict_types=1);

namespace Dedi\SyliusTaxonTypePlugin\Form\Extension;

use Dedi\SyliusTaxonTypePlugin\Model\TaxonInterface;
use Dedi\SyliusTaxonTypePlugin\Model\TypedTaxonInterface;
use Sylius\Bundle\TaxonomyBundle\Form\Type\TaxonType;
use Symfony\Component\Form\AbstractTypeExtension;
use Symfony\Component\Form\Extension\Core\Type\HiddenType;
use Symfony\Component\Form\FormBuilderInterface;

final class TaxonTypeExtension extends AbstractTypeExtension
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $taxon = $options['data'];
        $taxonType = TypedTaxonInterface::DEFAULT_TYPE;

        if ($taxon instanceof TaxonInterface) {
            $taxonType = $taxon->getType();
        }

        $builder->add('type', HiddenType::class, [
            'data' => $taxonType,
        ]);
    }

    public static function getExtendedTypes(): iterable
    {
        return [TaxonType::class];
    }
}
